with GNATCOM.IInterface;

with GNATCOM.Errors;

package body MSHTML.ISVGTransformList_Interface is

   procedure Initialize (This : in out ISVGTransformList_Type) is
   begin
      Set_IID (This, IID_ISVGTransformList);
   end Initialize;

   function Pointer (This : ISVGTransformList_Type)
     return Pointer_To_ISVGTransformList
   is
   begin
      return To_Pointer_To_ISVGTransformList (Address (This));
   end Pointer;

   procedure Attach (This    : in out ISVGTransformList_Type;
                     Pointer : in     Pointer_To_ISVGTransformList)
   is
   begin
      Attach (This, GNATCOM.IInterface.To_Pointer_To_IUnknown
              (Pointer.all'Address));
   end Attach;

   procedure Put_numberOfItems
     (This : ISVGTransformList_Type;
      p    : Interfaces.C.long)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Put_numberOfItems
         (Pointer (This),
          p));

   end Put_numberOfItems;

   function Get_numberOfItems
     (This : ISVGTransformList_Type)
     return Interfaces.C.long
   is
       RetVal : aliased Interfaces.C.long;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.Get_numberOfItems
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end Get_numberOfItems;

   procedure clear
     (This : ISVGTransformList_Type)
   is
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.clear
         (Pointer (This)));

   end clear;

   function initialize
     (This     : ISVGTransformList_Type;
      newItem  : Pointer_To_ISVGTransform)
     return Pointer_To_ISVGTransform
   is
       RetVal : aliased Pointer_To_ISVGTransform;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.initialize
         (Pointer (This),
          newItem,
          RetVal'Unchecked_Access));

      return RetVal;
   end initialize;

   function getItem
     (This     : ISVGTransformList_Type;
      index    : Interfaces.C.long)
     return Pointer_To_ISVGTransform
   is
       RetVal : aliased Pointer_To_ISVGTransform;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.getItem
         (Pointer (This),
          index,
          RetVal'Unchecked_Access));

      return RetVal;
   end getItem;

   function insertItemBefore
     (This     : ISVGTransformList_Type;
      newItem  : Pointer_To_ISVGTransform;
      index    : Interfaces.C.long)
     return Pointer_To_ISVGTransform
   is
       RetVal : aliased Pointer_To_ISVGTransform;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.insertItemBefore
         (Pointer (This),
          newItem,
          index,
          RetVal'Unchecked_Access));

      return RetVal;
   end insertItemBefore;

   function replaceItem
     (This     : ISVGTransformList_Type;
      newItem  : Pointer_To_ISVGTransform;
      index    : Interfaces.C.long)
     return Pointer_To_ISVGTransform
   is
       RetVal : aliased Pointer_To_ISVGTransform;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.replaceItem
         (Pointer (This),
          newItem,
          index,
          RetVal'Unchecked_Access));

      return RetVal;
   end replaceItem;

   function removeItem
     (This     : ISVGTransformList_Type;
      index    : Interfaces.C.long)
     return Pointer_To_ISVGTransform
   is
       RetVal : aliased Pointer_To_ISVGTransform;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.removeItem
         (Pointer (This),
          index,
          RetVal'Unchecked_Access));

      return RetVal;
   end removeItem;

   function appendItem
     (This     : ISVGTransformList_Type;
      newItem  : Pointer_To_ISVGTransform)
     return Pointer_To_ISVGTransform
   is
       RetVal : aliased Pointer_To_ISVGTransform;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.appendItem
         (Pointer (This),
          newItem,
          RetVal'Unchecked_Access));

      return RetVal;
   end appendItem;

   function createSVGTransformFromMatrix
     (This     : ISVGTransformList_Type;
      newItem  : Pointer_To_ISVGMatrix)
     return Pointer_To_ISVGTransform
   is
       RetVal : aliased Pointer_To_ISVGTransform;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.createSVGTransformFromMatrix
         (Pointer (This),
          newItem,
          RetVal'Unchecked_Access));

      return RetVal;
   end createSVGTransformFromMatrix;

   function consolidate
     (This     : ISVGTransformList_Type)
     return Pointer_To_ISVGTransform
   is
       RetVal : aliased Pointer_To_ISVGTransform;
   begin
      GNATCOM.Errors.Error_Check
        (Pointer (This).Vtbl.consolidate
         (Pointer (This),
          RetVal'Unchecked_Access));

      return RetVal;
   end consolidate;

end MSHTML.ISVGTransformList_Interface;

